# Which version of Python to build with.  Used to assemble python
# binary name so use '2.4', '2.5', '2.6' etc.
%if %{?pyver:0}%{!?pyver:1}
    %if 0%{?suse_version} > 1130
    %define pyver 2.7
    %endif
    %if 0%{?suse_version} == 1110 || 0%{?suse_version} == 1120 || 0%{?suse_version} == 1130
    %define pyver 2.6
    %endif
    %if 0%{?suse_version} == 1020 || 0%{?suse_version} == 1030 || 0%{?suse_version} == 1100
    %define pyver 2.5
    %endif
    %if 0%{?suse_version} <= 1010
    %define pyver 2.4
    %endif
%endif

# get path to python_sitearch for opensuse < 1120
%if 0%{?suse_version} < 1120
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

Summary:	GDAL/OGR - a translator library for raster and vector geospatial data formats
Name:		libgdal1
Version:	1.8.0
Release:	1.62
License:	MIT licence; Copyright by Frank Warmerdam
Group:		Development/Libraries
Source0:	gdal-%{version}.tar.bz2
Patch0:		gdal-python_install.patch
Patch1:		gdal-doxy.patch
Patch2:		gdal-perl.patch
URL:		http://www.gdal.org/
BuildRequires:	gcc-c++
BuildRequires:	chrpath
BuildRequires:	autoconf >= 2.52
BuildRequires:	automake
#BuildRequires:	libcfitsio-devel
BuildRequires:	doxygen >= 1.4.2
BuildRequires:	libexpat-devel >= 1.95.0
BuildRequires:	libgeos-devel >= 3
BuildRequires:	openjpeg2-devel
BuildRequires:	giflib-devel
BuildRequires:	hdf-devel >= 4.0
%if 0%{?suse_version} >= 1100
BuildRequires:	libjasper-devel
%endif
#BuildRequires:	libcsf-devel
#BuildRequires:	libdap-devel >= 3.10
BuildRequires:	libgeotiff-devel >= 1.2.1
BuildRequires:	libjpeg-devel
BuildRequires:	libpoppler-devel
BuildRequires:	libpng-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtiff-devel >= 3.6.0
BuildRequires:	libtool
BuildRequires:	libnetcdf-devel
#BuildRequires:	ogdi-devel >= 3.1
#BuildRequires:	pcidsk-devel
#BuildRequires:	perl-devel
BuildRequires:	libproj-devel
BuildRequires:	unixODBC-devel 
BuildRequires:	mysql-devel
BuildRequires:	sqlite-devel
BuildRequires:	postgresql-devel
BuildRequires:	python-devel >= %{pyver}
BuildRequires:	python-setuptools
BuildRequires:	python-numpy-devel
BuildRequires:	ruby-devel
BuildRequires:	sqlite3-devel >= 3
BuildRequires:	swig
BuildRequires:	texlive-latex
BuildRequires:	zlib-devel >= 1.1.4
#BuildRequires:  -post-build-checks
%if 0%{?suse_version} >= 1120 || 0%{?sles_version} || 0%{?centos_version} || 0%{?rhel_version}
Requires:	xerces-c
BuildRequires:	libxerces-c-devel
%else
Requires:	Xerces-c
BuildRequires:	libXerces-c-devel
%endif
Requires:	libgeos0 >= 3
Requires:	libgeotiff >= 1.2.1
Requires:	libpng 
Requires:	libtiff 
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

%description
GDAL is a translator library for raster geospatial data formats that
is released under an Open Source license. As a library, it presents a
single abstract data model to the calling application for all
supported formats. The related OGR library (which lives within the
GDAL source tree) provides a similar capability for simple features
vector data.

%package -n libgdal-devel
Summary:	GDAL library header files
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libexpat-devel >= 1.95.0
Requires:	libgeos-devel >= 3
Requires:	hdf-devel >= 4.0
%if 0%{?suse_version} >= 1100
BuildRequires:  libjasper-devel
%endif
Requires:	libgeotiff-devel >= 1.2.1
Requires:	libjpeg-devel
Requires:	libpng-devel
Requires:	libstdc++-devel
Requires:	libtiff-devel
Requires:	libnetcdf-devel
#Requires:	ogdi-devel >= 3.1
Requires:	postgresql-devel
Requires:	sqlite3-devel >= 3
Requires:	unixODBC-devel
%if 0%{?suse_version} >= 1120 || 0%{?sles_version} || 0%{?centos_version} || 0%{?rhel_version}
Requires:	xerces-c
BuildRequires:	libxerces-c-devel
%else
Requires:	Xerces-c
BuildRequires:	libXerces-c-devel
%endif

%description -n libgdal-devel
Development Libraries for the GDAL file format library

%package -n gdal
Summary:	GDAL static libraries
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description -n gdal
GDAL and OGR are translator libraries for raster and vector geospatial data
formats. As a library, it presents a single abstract data model to the calling
application for all supported formats.

%package -n perl-gdal
Summary:	Perl bindings for GDAL
Group:		Development/Languages/Perl
Requires:	%{name} = %{version}-%{release}
Requires:	perl = %{perl_version} perl-base

%description -n perl-gdal
Perl bindings for GDAL - Geo::GDAL, Geo::OGR and Geo::OSR modules.

%package -n python-gdal
Summary:	GDAL Python module
Group:		Libraries/Python
Requires:	%{name} = %{version}-%{release}
Requires:	python >= %{pyver}

%description -n python-gdal
The GDAL python modules provide support to handle multiple GIS file formats.

%prep
%setup -q -n gdal-%{version}
%patch0 -p1
%if 0%{?suse_version} < 1130
%patch1 -p1
%endif
%patch2 -p1

# need to regenerate (old ones don't support perl 5.10)
%{__rm} swig/perl/{gdal_wrap.cpp,gdalconst_wrap.c,ogr_wrap.cpp,osr_wrap.cpp}
# includes updated for Ruby 1.9
#%{__rm} swig/ruby/{gdal_wrap.cpp,gdalconst_wrap.c,ogr_wrap.cpp,osr_wrap.cpp}

%{__rm} -r man

%build
# $PYTHON_INCLUDES is set only with --with-ogpython, but we have --with-python,
# and $PYTHON_INCLUDES is needed to detect numpy properly
export PYTHON_INCLUDES=-I%{py_incdir}

%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
# disable grass/libgrass here, it is built in separate gdal-grass package

# bugfix: see http://old.nabble.com/Strange-build-behaviour-td26741825.html                  
# otherwise "Xerces-C support" (and therefore NAS support) is disabled,                      
# due to incorrect ordering of "-l" in configure for conftest.cpp                            
export SUSE_ASNEEDED=0

%configure \
        --prefix=%{_prefix} \
        --includedir=%{_includedir}/gdal \
        --datadir=%{_datadir}/gdal \
        --with-threads      \
        --disable-static          \
        --with-geotiff=internal   \
        --with-libtiff=internal   \
        --with-libz               \
        --with-cfitsio=no         \
        --with-netcdf             \
        --with-hdf4               \
        --with-geos               \
        --with-expat              \
%if 0%{?suse_version} >= 1100
        --with-jasper             \
%endif
        --with-png                \
        --with-gif                \
        --with-jpeg               \
        --with-odbc               \
        --with-mysql              \
        --with-pg                 \
        --with-ogdi               \
        --with-poppler            \
        --with-curl               \
        --with-openjpeg=/usr      \
        --with-python             \
        --with-perl               \
        --with-xerces=yes         \
        --with-xerces-lib="-lxerces-c" \
        --with-xerces-inc=/usr/include/xercesc \
        --without-pcraster  \
        --with-jpeg12=no      \
        --without-libgrass   \
        --without-grass \
        --enable-shared

# regenerate where needed
%{__make} -j1 -C swig/perl generate

%{__make} -j1

%{__make} -j1 docs

%{__make} -j1 man

%install
rm -rf %{buildroot}

%{__make} -j1 install install-man \
	DESTDIR=%{buildroot}

rm -rf _html
cp -a html _html
cp -a ogr/html _html/ogr

# fix python installation path
sed -i 's|setup.py install|setup.py install --prefix=%{_prefix} --root=%{buildroot}|' swig/python/GNUmakefile

make    DESTDIR=%{buildroot} \
        install

make    DESTDIR=%{buildroot} \
        INST_MAN=%{_mandir} \
        install-man

# cleanup junks
rm -rf %{buildroot}%{_includedir}/gdal/gdal
rm -rf %{buildroot}%{_bindir}/gdal_sieve.dox
rm -rf %{buildroot}%{_bindir}/gdal_fillnodata.dox
for junk in {.exists,.cvsignore} ; do
	find %{buildroot} -name "$junk" -exec rm -rf '{}' \;
done

# ERROR: RPATH "/usr/src/packages/BUILD/gdal-1.8.0" on ... is not allowed
%__chmod 644 %{buildroot}%{perl_vendorarch}/auto/Geo/GDAL/Const/Const.so
%__chmod 644 %{buildroot}%{perl_vendorarch}/auto/Geo/GDAL/GDAL.so
%__chmod 644 %{buildroot}%{perl_vendorarch}/auto/Geo/OGR/OGR.so
%__chmod 644 %{buildroot}%{perl_vendorarch}/auto/Geo/OSR/OSR.so
chrpath --delete %{buildroot}%{perl_vendorarch}/auto/Geo/GDAL/Const/Const.so
chrpath --delete %{buildroot}%{perl_vendorarch}/auto/Geo/GDAL/GDAL.so
chrpath --delete %{buildroot}%{perl_vendorarch}/auto/Geo/OGR/OGR.so
chrpath --delete %{buildroot}%{perl_vendorarch}/auto/Geo/OSR/OSR.so

%clean
rm -rf %{buildroot}

%post	-p /sbin/ldconfig

%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%{_libdir}/*.so.*
%{_libdir}/*.so


%files -n gdal
%defattr(644,root,root,755)
%doc NEWS PROVENANCE.TXT
%attr(755,root,root) %{_bindir}/epsg_tr.py
%attr(755,root,root) %{_bindir}/esri2wkt.py
%attr(755,root,root) %{_bindir}/gcps2vec.py
%attr(755,root,root) %{_bindir}/gcps2wld.py
%attr(755,root,root) %{_bindir}/gdal2tiles.py
%attr(755,root,root) %{_bindir}/gdal2xyz.py
%attr(755,root,root) %{_bindir}/gdal_calc.py
%attr(755,root,root) %{_bindir}/gdal_contour
%attr(755,root,root) %{_bindir}/gdallocationinfo
%attr(755,root,root) %{_bindir}/gdal_fillnodata.py
%attr(755,root,root) %{_bindir}/gdal_grid
%attr(755,root,root) %{_bindir}/gdal_merge.py
%attr(755,root,root) %{_bindir}/gdal_polygonize.py
%attr(755,root,root) %{_bindir}/gdal_proximity.py
%attr(755,root,root) %{_bindir}/gdal_rasterize
%attr(755,root,root) %{_bindir}/gdal_retile.py
%attr(755,root,root) %{_bindir}/gdal_sieve.py
%attr(755,root,root) %{_bindir}/gdal_translate
%attr(755,root,root) %{_bindir}/gdaladdo
%attr(755,root,root) %{_bindir}/gdalbuildvrt
%attr(755,root,root) %{_bindir}/gdalchksum.py
%attr(755,root,root) %{_bindir}/gdaldem
%attr(755,root,root) %{_bindir}/gdalenhance
%attr(755,root,root) %{_bindir}/gdalident.py
%attr(755,root,root) %{_bindir}/gdalimport.py
%attr(755,root,root) %{_bindir}/gdalinfo
%attr(755,root,root) %{_bindir}/gdalmanage
%attr(755,root,root) %{_bindir}/gdaltindex
%attr(755,root,root) %{_bindir}/gdaltransform
%attr(755,root,root) %{_bindir}/gdalwarp
%attr(755,root,root) %{_bindir}/mkgraticule.py
%attr(755,root,root) %{_bindir}/nearblack
%attr(755,root,root) %{_bindir}/ogr2ogr
%attr(755,root,root) %{_bindir}/ogrinfo
%attr(755,root,root) %{_bindir}/ogrtindex
%attr(755,root,root) %{_bindir}/pct2rgb.py
%attr(755,root,root) %{_bindir}/rgb2pct.py
%attr(755,root,root) %{_bindir}/testepsg
%{_datadir}/gdal
%{_mandir}/man1/gdal2tiles.1*
%{_mandir}/man1/gdal_contour.1*
%{_mandir}/man1/gdal_fillnodata.1*
%{_mandir}/man1/gdal_grid.1*
%{_mandir}/man1/gdal_merge.1*
%{_mandir}/man1/gdal_rasterize.1*
%{_mandir}/man1/gdal_retile.1*
%{_mandir}/man1/gdal_sieve.1*
%{_mandir}/man1/gdal_translate.1*
%{_mandir}/man1/gdal_utilities.1*
%{_mandir}/man1/gdallocationinfo.1*
%{_mandir}/man1/gdaladdo.1*
%{_mandir}/man1/gdalbuildvrt.1*
%{_mandir}/man1/gdaldem.1*
%{_mandir}/man1/gdalinfo.1*
%{_mandir}/man1/gdaltindex.1*
%{_mandir}/man1/gdaltransform.1*
%{_mandir}/man1/gdalwarp.1*
%{_mandir}/man1/nearblack.1*
%{_mandir}/man1/ogr2ogr.1*
%{_mandir}/man1/ogr_utilities.1*
%{_mandir}/man1/ogrinfo.1*
%{_mandir}/man1/ogrtindex.1*
%{_mandir}/man1/pct2rgb.1*
%{_mandir}/man1/rgb2pct.1*
%if 0%{?suse_version} > 1120
%{_mandir}/man1/BandProperty.1.*
%{_mandir}/man1/ColorAssociation.1.*
%{_mandir}/man1/CutlineTransformer.1.*
%{_mandir}/man1/DatasetProperty.1.*
%{_mandir}/man1/EnhanceCBInfo.1.*
%{_mandir}/man1/GDALAspectAlgData.1.*
%{_mandir}/man1/GDALColorReliefDataset.1.*
%{_mandir}/man1/GDALColorReliefRasterBand.1.*
%{_mandir}/man1/GDALGeneric3x3Dataset.1.*
%{_mandir}/man1/GDALGeneric3x3RasterBand.1.*
%{_mandir}/man1/GDALHillshadeAlgData.1.*
%{_mandir}/man1/GDALSlopeAlgData.1.*
%{_mandir}/man1/NamedColor.1.*
%{_mandir}/man1/ListFieldDesc.1.*
%{_mandir}/man1/OGRSplitListFieldLayer.1.*
%{_mandir}/man1/VRTBuilder.1.*
%endif

%files -n libgdal-devel
%defattr(644,root,root,755)
%doc _html/*
%attr(755,root,root) %{_bindir}/gdal-config
%attr(755,root,root) %{_libdir}/libgdal.so
%{_libdir}/libgdal.la
%dir %{_includedir}/gdal
%{_includedir}/gdal/*.h
%{_mandir}/man1/gdal-config.1*


%files -n perl-gdal
%defattr(644,root,root,755)
%{perl_vendorarch}/Geo/GDAL.pm
%dir %{perl_vendorarch}/Geo/GDAL
%{perl_vendorarch}/Geo/GDAL/Const.pm
%{perl_vendorarch}/Geo/OGR.pm
%{perl_vendorarch}/Geo/OSR.pm
%dir %{perl_vendorarch}/Geo
%dir %{perl_vendorarch}/auto/Geo
%dir %{perl_vendorarch}/auto/Geo/GDAL
%attr(755,root,root) %{perl_vendorarch}/auto/Geo/GDAL/GDAL.so
%dir %{perl_vendorarch}/auto/Geo/GDAL/Const
%{perl_vendorarch}/auto/Geo/GDAL/Const/Const.bs
%attr(755,root,root) %{perl_vendorarch}/auto/Geo/GDAL/Const/Const.so
%dir %{perl_vendorarch}/auto/Geo/OGR
%{perl_vendorarch}/auto/Geo/GDAL/GDAL.bs
%attr(755,root,root) %{perl_vendorarch}/auto/Geo/OGR/OGR.so
%dir %{perl_vendorarch}/auto/Geo/OSR
%{perl_vendorarch}/auto/Geo/OSR/OSR.bs
%{perl_vendorarch}/auto/Geo/OGR/OGR.bs
%attr(755,root,root) %{perl_vendorarch}/auto/Geo/OSR/OSR.so
%exclude /usr/lib/perl5/*/*-linux-thread-multi/perllocal.pod
%exclude %{perl_vendorarch}/Geo/*.dox
%exclude %{perl_vendorarch}/Geo/GDAL/*.dox
%exclude %{perl_vendorarch}/auto/Geo/*/.packlist
%exclude %{perl_vendorarch}/auto/Geo/GDAL/Const/.packlist

%files -n python-gdal
%defattr(644,root,root,755)
%{python_sitearch}/gdal.py*
%{python_sitearch}/gdalconst.py*
%{python_sitearch}/gdalnumeric.py*
%{python_sitearch}/ogr.py*
%{python_sitearch}/osr.py*
%{python_sitearch}/GDAL-*.egg-info
%dir %{python_sitearch}/osgeo
%attr(755,root,root) %{python_sitearch}/osgeo/_gdal.so
%attr(755,root,root) %{python_sitearch}/osgeo/_gdal_array.so
%attr(755,root,root) %{python_sitearch}/osgeo/_gdalconst.so
%attr(755,root,root) %{python_sitearch}/osgeo/_ogr.so
%attr(755,root,root) %{python_sitearch}/osgeo/_osr.so
%{python_sitearch}/osgeo/*.py*
%exclude /usr/local/%{_lib}/python%{pyver}/site-packages
%exclude /usr/lib/debug/usr/local/%{_lib}/python%{pyver}/site-packages

%changelog
* Mon Jan 24 2011 Otto Dassau <dassau@gbd-consult.de> 1.8.0
- update to new version
* Sat Nov 13 2010 Otto Dassau 1.7.3
- update to new version with many small fixes and changes
* Thu Jun 24 2010 Otto Dassau 1.7.1
- added soname patch for building without libtool
* Wed Apr 14 2010 Otto Dassau 1.7.1
- added perl and python packages with help from fedora spec by Balint Cristian 
* Thu Feb 11 2010 Otto Dassau 1.7.1
- update to new version
* Mon Nov 30 2009 Otto Dassau 1.6.3
- update to new version
* Tue Nov 24 2009 Otto Dassau 1.6.2
- update to new version
* Mon May 18 2009 Otto Dassau 1.6.1
- update to new version
* Wed Feb 18 2009 Otto Dassau 1.6.0
- update to new version
- adapted hdf4 patch
- removed ogpython and enabled current python bindings
* Thu Dec 4 2008 Otto Dassau 1.5.3
- new patch to prevent getting upside-down images with NetCDF (ticket 2654)
* Tue Oct 21 2008 Otto Dassau 1.5.3
- update to new version
* Thu Jun 12 2008 Otto Dassau 1.5.2
- added netcdf support after solving hdf4-netcdf conflict
* Thu Jun 12 2008 Otto Dassau 1.5.2
- update to new bugfix version and added hdf4 support
* Sun Mar 23 2008 Otto Dassau 1.5.1
- update to new version
* Mon Dec 31 2007 Otto Dassau 1.5.0
- added with-ogpython
- BuildRequires: +unixODBC-devel, +libgeos-devel
- added more tools
* Thu Dec 20 2007 Otto Dassau 1.4.4
- update to 1.4.4 and added mysql support
* Mon Aug 13 2007 Dirk Stoecker 1.4.2
- adapted for openSUSE BuildService
* Mon Jul 16 2007 Otto Dassau 1.4.2
- first built
* Mon Jun 11 2007 Otto Dassau 1.4.1
- first built
* Tue Dec 19 2006 Otto Dassau 1.3.2
- built on SuSE 10.2
* Mon Jun 19 2006 Markus Neteler 1.3.2
- added DB support; gdal_rasterize
* Wed Jan 25 2006 Otto Dassau 1.3.1
- adapted to SuSE 10.0

